unit GWGExporterOOC;

interface

uses
  Windows, Messages, SysUtils, Classes, DB,
  DBCTrls, DBGrids, Dialogs , clipbrd, comobj,
  Variants, Forms;
var
    //Thanx to Tomasz Wasiuk
    CXlsEof: array[0..1] of Word = ($0A, 00);
    CXlsLabel: array[0..5] of Word = ($204, 0, 0, 0, 0, 0);
    CXlsNumber: array[0..4] of Word = ($203, 14, 0, 0, 0);
    CXlsBoolerr: array[0..5] of Word = ($205, 8,0, 0, 0, 0);
    CXlsRk: array[0..4] of Word = ($27E, 10, 0, 0, 0);

type

  TProgress =
  procedure(Sender : TObject; var Progress : Integer ; SendedRows : Integer ; m_time : TdateTime ) of object;
  TGWGExporterOOC = class(TComponent)
  private
    MyWatch : Boolean;
    MyFirst : Boolean;
    FDataLink: TDataLink;
    FDataSet: TDataSet;
    FDBGrid: TDBGrid;
    FExport_Format : Integer;
    fRows_To_Send : Integer;
    fFirst_Rows_To_Send : Integer;
    fLast_Rows_To_Send : Integer;
    fFileToSave : String;
    fExt_File : String;
    fCopyToNewCalc : Boolean;

    fVisibleAfterExport : Boolean;
    fSaveAfterExport : Boolean;
    fSaveFormat : String;
    FonProgress : Tprogress;
    SaveDialog1 : TSaveDialog;
    fIniFile : String;

    my_time : Tdatetime;
    procedure setOnProgress(const Value : TProgress );


    { Private declarations }
  protected
    function  GetDataSource: TDataSource;
    procedure SetDataSource(Value: TDataSource);
    procedure SetDataSet(const Value: TDataSet);
    procedure SetDBGrid(Value: TDBGrid);
    procedure SetRowsToSend(Value: Integer);
    procedure setFirstRowsToSend(Value: Integer);
    procedure setLastRowsToSend(Value: Integer);
    procedure SetFileToSave(strsavefile : String);
    procedure setFExport_Format(Value : Integer);

//to xls write...
    procedure XlsBeginStream(const filename : String);
    procedure XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word;
      const AValue: string);
    procedure XlsEndStream(XlsStream: TStream);
    procedure XlsWriteCellNumber(XlsStream: TStream; const ACol, ARow: Word;
      const AValue: Double);
    procedure XlsWriteCellRk(XlsStream: TStream; const ACol, ARow: Word;
      const AValue: Integer);
    procedure XlsWriteCellBoolerr(XlsStream: TStream; const ACol, ARow: Word;
      const AValue: Boolean);
//to OPENOFFICE_TOOLS...
    function convertToURL(winAddr: String): String;
    function dummyArray: Variant;
    { Protected declarations }
  public
    constructor create(Aowner : Tcomponent) ; override;
    destructor Destroy; override;
    procedure GoToSCalc;
    procedure setDefaultProperty;
    { DONE : dodaj destructor ... }

    { Public declarations }
  published

    property DataSet: TDataSet
      read  FDataSet
      write SetDataSet;
    property DataSource: TDataSource
      read GetDataSource
      write SetDataSource;
    property DBGrid: TDBGrid
      read FDBGrid
      write SetDBGrid;
    property RowsToSend : Integer
      read fRows_to_Send
      write setRowsToSend
      default 65535;
    property FirstRowsToSend : Integer
      read fFirst_Rows_to_Send
      write setFirstRowsToSend
      default 1;
    property LastRowsToSend : Integer
      read fLast_Rows_to_Send
      write setLastRowsToSend
      default 65535;
    property OnProgress : TProgress
      read FonProgress
      write SetonProgress ;
    property EXportFormat : Integer
      read  FExport_Format
      write setFExport_Format
      default 1 ;
    property FileToSave : String
      read  fFileToSave
      write SetFileToSave;
    property VisibleAfterExport : Boolean
      read  fVisibleAfterExport
      write fVisibleAfterExport
      default True ;
    property CopyToNewCalc : Boolean
      read  fCopyToNewCalc
      write fCopyToNewCalc
      default False ;

    property SaveAfterExport : Boolean
      read fSaveAfterExport
      write fSaveAfterExport
      default False ;
    property IniFile : String
      read  fIniFile
      write fIniFile;      
    property SaveFormat : String
      read  fSaveFormat;

    { Published declarations }
  end;

procedure Register;
 {$R GWGExporterOOC.res}
implementation
//Thanx to Bernard Marcell
const USASCIIexcl =   // US-ASCII characters to be replaced by % hexa
  '%%25 %20<%3C>%3E#%23"%22{%7B}%7D|%7C\%5C^%5E[%5B]%5D`%60';
const UTF8chars =        // non US-ASCII characters to be replaced by % hexa % hexa
  '%C3%80%C3%81%C3%82%C3%83%C3%84%C3%85%C3%86%C3%87%C3%88%C3%89%C3%8A%C3%8B%C3%8C%C3%8D%C3%8E%C3%8F' +
  '%C3%90%C3%91%C3%92%C3%93%C3%94%C3%95%C3%96%C3%97%C3%98%C3%99%C3%9A%C3%9B%C3%9C%C3%9D%C3%9E%C3%9F' +
  '%C3%A0%C3%A1%C3%A2%C3%A3%C3%A4%C3%A5%C3%A6%C3%A7%C3%A8%C3%A9%C3%AA%C3%AB%C3%AC%C3%AD%C3%AE%C3%AF' +
  '%C3%B0%C3%B1%C3%B2%C3%B3%C3%B4%C3%B5%C3%B6%C3%B7%C3%B8%C3%B9%C3%BA%C3%BB%C3%BC%C3%BD%C3%BE%C3%BF' +
  '%C5%92%C5%93';

const URLprefix : Array [1..7] of String =
    ('file:', 'ftp:', 'news:', 'http:', 'mailto:', 'macro:', 'private:');

procedure TGWGExporterOOC.SetFileToSave(strsavefile : String);
begin
  if not (csDesigning in ComponentState) then
  begin
    fFileToSave :=strsavefile;
  end;

  if MyFirst = True then
  begin
    MyFirst:=False;
    exit;
  end;
  if MyWatch = False then exit;
  if csDesigning in ComponentState then
  begin
    SaveDialog1.Filter:='MsExcel Files (*.xls)|*.xls';
    SaveDialog1.DefaultExt:='xls';
    Savedialog1.FileName:= 'Export.xls';
    Savedialog1.Title:= 'Save as MsExcel files';
    if SaveDialog1.Execute then
    begin
      MyWatch := False;
      fFileToSave := SaveDialog1.FileName;
      MyWatch := True;
    end ;
  end;



end;

procedure TGWGExporterOOC.setFExport_Format(Value : Integer);
begin
  if (value < 1) or (value > 5) then value := 1;

  FExport_Format := Value;

  if Value = 1 then
  begin
    fSaveFormat:='Excel97/2000/XP';
    fExt_File :='.XLS';
  end
  else
  if Value = 2 then
  begin
    fSaveFormat:='Excel95';
    fExt_File :='.XLS';
  end
  else
  if Value = 3 then
  begin
    fSaveFormat:='Calc OpenOffice';
    fExt_File :='.ODS';
  end
  else
  if Value = 4 then
  begin
    fSaveFormat:='TXT TAB delimited';
    fExt_File :='.TXT';
  end
  else
  if Value = 5 then
  begin
    fSaveFormat:='CSV';
    fExt_File :='.CSV';
  end;

end;

procedure TGWGExporterOOC.setOnProgress(const Value : TProgress );
begin
  FonProgress := Value;
end;

procedure TGWGExporterOOC.setFirstRowsToSend(Value: Integer);
begin
  if Value <= 0 Then Value := 1;
  if VALUE > fLast_Rows_To_Send THEN fLast_Rows_To_Send := Value;
  fFirst_Rows_To_Send := Value;
  SetRowsToSend(fLast_Rows_To_Send - Value + 1);

end;

procedure TGWGExporterOOC.setLastRowsToSend(Value: Integer);
begin
  if Value <= 0 Then Value := 1;
  if VALUE < fFirst_Rows_To_Send THEN fFirst_Rows_To_Send := Value;
  fLast_Rows_To_Send := Value;
  SetRowsToSend(Value + 1 - fFirst_Rows_To_Send);
end;


procedure TGWGExporterOOC.SetRowsToSend(Value: Integer);
begin
  if Value <= 0 Then Value := 1;
  if VALUE > 65535 THEN Value := 65535;
  fRows_To_Send := Value;
  fLast_Rows_To_Send := Value + fFirst_Rows_To_Send-1;
end;

constructor TGWGExporterOOC.create(Aowner : Tcomponent) ;
begin
  inherited create(Aowner);
  MyFirst := True;
  FDataLink := TDataLink.Create;
  MyWatch := False;
  Savedialog1 := TSaveDialog.Create(self);
  setDefaultProperty;
end;

destructor TGWGExporterOOC.Destroy ;
begin
  FDataLink.Free;
  Savedialog1.free;
  inherited Destroy;
end;

procedure TGWGExporterOOC.SetDBGrid(Value: TDBGrid);
begin
  FDBGrid:=Value;
  FDataSet := nil;
  FDataLink.DataSource:=nil;
  if value<>nil then
  Value.FreeNotification( Self );
end;


procedure TGWGExporterOOC.SetDataSet(const Value: TDataSet);
begin
  FDataSet := Value;
  FDBGrid := nil;
  FDataLink.DataSource := nil;
  if Value <> nil then
  Value.FreeNotification(Self);
end;

procedure TGWGExporterOOC.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  FDataSet := nil;
  FDBGrid := nil;
  if Value <> nil then
  Value.FreeNotification( Self );
end;


function TGWGExporterOOC.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure Register;
begin
  RegisterComponents('Standard', [TGWGExporterOOC]);
end;
procedure TGWGExporterOOC.GoToSCalc;
var

  serviceManager,
  desktop,
  myprop,
  mypropo,
  disp,
  calc,
  mydesk,
  calc2,
  mydesk2,
  my_properites,
  mypropo0,
  mypropo1,
  mypropo2,
  mypropo3      

    : Variant;


  C1,C2 : TDateTime;
  i, i2 : Integer;
  i3 : integer;

  il_fields : Smallint;
  WH_UNKN : Smallint;


  isunkn : Boolean;
  tnext : boolean;
  allowexp : string;
  allowexp2 : string;
  
  myFile : string;

  licznik : integer;

  dane_pole   : Array[1..256] of string;
  dane_oper   : Array[1..256] of string;
  dane_type   : Array[1..256] of string;
  dane_cons   : Array[1..256] of string;
  plik     : textfile;

  tab_pola : array [0..256] of integer;
  nazw_pola : TStringList;
  nazw_pola2 : TStringList;
  FDS : TDataSet;
  Progress : Integer;
  Fname : String;
  FStream : TFileStream;
  CellLabel : string;
  s : String;
begin


  // Begin Settings
  tnext := false;
  c1:=now;

  allowexp:='';
  isunkn := False; // field ftUnknown

  FDS := nil;

  If FDataSet <> nil then
  begin
    FDS := FDataSet;
  end;

  If FDataLink.DataSource <> nil then
  begin
    if FDataLink.DataSource.DataSet <> nil then
    begin
      FDS := FDataLink.DataSource.DataSet;
    end;
  end;
  If FDBGrid  <> nil then
  begin
    if FDBGrid.DataSource <> nil then
    begin
      if FDBGrid.DataSource.DataSet <> nil then
      begin
        FDS := FDBGrid.DataSource.DataSet;
      end;
    end;
  end;

  if (FDS = nil) then
  begin
    ShowMessage('Data is not assigned...');
    exit;
  end;
  if (FDS <> nil) and (not FDS.Active) then
  begin
    ShowMessage('Data is not open...');
    exit;
  end;
//******************************************
// incorrect settings
  if FirstRowsToSend > FDS.RecordCount then
  setFirstRowsToSend(1);

  if fds.RecordCount < RowsToSend then
  SetRowsToSend(fds.RecordCount);

  if LastRowsToSend > FDS.RecordCount then
  setLastRowsToSend(FDS.RecordCount);

//******************************************

// default settings table of import
  For i := 1 to FDS.FieldCount+1 do
  begin
    allowexp:= allowexp+'N';
  end;

  il_fields := FDS.FieldCount;

  for i := 0 to il_fields-1 do
  begin
    if FDS.FieldDefs[i].DataType =  ftUnknown then
    begin
     isunkn := True; // IS ftUnkonown
     WH_UNKN := i;   //Nr field ftUnknown
    end;
  end;

  if isunkn = False then dec(il_fields); 

  nazw_pola := TStringList.Create;

  For i := 0 to FDS.FieldCount-1 do
  nazw_pola.Add(FDS.Fields[i].FieldName);

  // Tables of import to field types
  For i := 0 to Il_fields do
  begin
    if FDS.FieldDefs[i].DataType =  ftString   then allowexp[i+1] := 'S'; //format to string
    if FDS.FieldDefs[i].DataType =  ftSmallint   then allowexp[i+1] := 'i'; // Integer
    if FDS.FieldDefs[i].DataType =  ftInteger   then allowexp[i+1] := 'i'; //...
    if FDS.FieldDefs[i].DataType =  ftWord   then allowexp[i+1] := 'i';
    if FDS.FieldDefs[i].DataType =  ftBoolean   then allowexp[i+1] := 'b';
    if FDS.FieldDefs[i].DataType =  ftFloat   then allowexp[i+1] := 'f';
    if FDS.FieldDefs[i].DataType =  ftCurrency   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftBCD   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftDate   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftTime   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftDateTime   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftAutoInc   then allowexp[i+1] := 'i';
    if FDS.FieldDefs[i].DataType =  ftMemo   then allowexp[i+1] := 'S';
    if FDS.FieldDefs[i].DataType =  ftFmtMemo   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftWideString   then allowexp[i+1] := 'S';
    if FDS.FieldDefs[i].DataType =  ftLargeint   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftGuid   then allowexp[i+1] := 'S';
    if FDS.FieldDefs[i].DataType =  ftFMTBcd   then allowexp[i+1] := 'T';
    if FDS.FieldDefs[i].DataType =  ftUnknown    then allowexp[i+1] := 'U';
  end;

  //delete unvisible field ftUnknown
  if isunkn then
  begin
    system.Delete(allowexp, WH_UNKN+1,1);
  end;
  for i := 0 to length(allowexp) do tab_pola[i]:=i;

//*******************************
  If FDBGrid  <> nil then
  begin
    nazw_pola2 := TStringList.Create;

    i3 := FDBGrid.Columns.Count;

    for i := 0 to i3-1 do
    begin
      nazw_pola2.Add(FDBGrid.Columns[i].fieldname);
    end;

    for i :=  0 to nazw_pola2.Count-1 do
    begin
      for i2 := 0 to nazw_pola.Count-1 do
      begin
        if nazw_pola2[i] = nazw_pola[i2] then
        begin
          allowexp2:= allowexp2+allowexp[i2+1];
          tab_pola[i] := i2;
          break;
        end;
      end;
    end;
    allowexp:=allowexp2;
    nazw_pola := nazw_pola2;

  end;
//***************************************
fname := ExtractFilePath(Application.ExeName)+'EXPORT_PRB.XLS';
///**********************************************
//******** xls write begin (withOUT ini file) *****
//**********************************************
  IF (fIniFile = '')  THEN
  BEGIN
    XlsBeginStream(Fname);
    FStream := TFileStream.Create(fname, fmOpenReadWrite);
    FStream.Seek(FStream.size ,0);
//********
    FDS.First;
    if FirstRowsToSend <> 1 then fds.MoveBy(FirstRowsToSend-1);

    i3 := length(allowexp);
    if (FDBGrid = nil) and (not isunkn) then dec(i3);
//******** xls write FIRST ROW ***

    For i := 0 to i3-1 do
        XlsWriteCellLabel(FStream,i,0,nazw_pola[i]);
    nazw_pola.Free;

    if FDS.RecordCount = 0 then
    begin
      FStream.Free;
      exit;
    end;
    licznik := 0;
//******************************************
//****** Write cells XLS
//___________________________________________
      repeat

        // firs record without next!!
        if tnext = true then FDS.Next
        else tnext := true;
        Application.ProcessMessages;
        inc(licznik);
        i3 := length(allowexp);
        if (FDBGrid = nil) and (not isunkn) then dec(i3);
        For i := 0 to i3-1 do
        begin

        // Is allowed fied to export ?
          if allowexp[i+1] <> 'N' then
          begin
           if  allowexp[i+1] = 'b' then
             XlsWriteCellBoolerr(FStream,i,licznik,FDS.Fields[tab_pola[i]].AsBoolean)
           else if allowexp[i+1] = 'f' then
             XlsWriteCellNumber(FStream,i,licznik,FDS.Fields[tab_pola[i]].AsFloat)
           else if allowexp[i+1] = 'i' then
             XlsWriteCellRk(FStream,i,licznik,FDS.Fields[tab_pola[i]].AsInteger)
           else
           begin;
             CellLabel:=FDS.Fields[tab_pola[i]].AsString;
             if CellLabel <> '' then
             XlsWriteCellLabel(FStream,i,licznik,CellLabel);
           end;
          end;
        end;

        if licznik mod 50 = 0 then
        begin
          Progress := (((licznik+1)*100) div RowsToSend) ;
          c2 := now;
          my_time := c2-c1;
          If Assigned(OnProgress) then
          OnProgress(self , Progress, licznik, my_time) ;
        end;
      until (licznik >= RowsToSend) or (FDS.eof);
//_______________________________________________

      Progress := (((licznik+1)*100) div RowsToSend) ;
      c2 := now;
      my_time := c2-c1;
      If Assigned(OnProgress) then
      OnProgress(self , Progress, licznik, my_time) ;

      XlsEndStream(FStream);
      FStream.Free;
    END;
//**********************************************
//******** xls write begin (with ini file) *****
//**********************************************
  IF (fIniFile <> '')  THEN
  BEGIN
    AssignFile(plik, fIniFile );
    Reset(plik);
    i :=1;
    repeat
      readln(plik, dane_pole[i]);
      readln(plik, dane_oper[i]);
      readln(plik, dane_type[i]);
      readln(plik, dane_cons[i]);
      inc(i);
    until eof(plik);
    closefile(plik);
    dec(i);
    i3 := i;

    XlsBeginStream(Fname);
    FStream := TFileStream.Create(fname, fmOpenReadWrite);
    FStream.Seek(FStream.size ,0);
//********
    FDS.First;
    if FirstRowsToSend <> 1 then fds.MoveBy(FirstRowsToSend-1);
//******** xls write FIRST ROW ***

    For i := 0 to i3-1 do
      XlsWriteCellLabel(FStream,i,0,dane_pole[i+1]);

    if FDS.RecordCount = 0 then
    begin
      FStream.Free;
      exit;
    end;
    licznik := 0;
//****************************
//****** Write cells XLS *****
//****************************
//___________________________________________
    repeat

      // firs record without next!!
      if tnext = true then FDS.Next
      else tnext := true;
      Application.ProcessMessages;
      inc(licznik);

      For i := 0 to i3-1 do
      begin
/// write with of table  ********
        If (UpperCase(dane_oper[i+1]) = 'WRITE') then
        begin
          if UpperCase(dane_type[i+1]) = 'N' then
             XlsWriteCellNumber(FStream,i,licznik,FDS.fieldbyname(dane_pole[i+1]).AsFloat)
            else
            if UpperCase(dane_type[i+1]) = 'I' then
               XlsWriteCellRk(FStream,i,licznik,FDS.fieldbyname(dane_pole[i+1]).AsInteger)
              else
              if  UpperCase(dane_type[i+1]) = 'B' then
                 XlsWriteCellBoolerr(FStream,i,licznik,FDS.fieldbyname(dane_pole[i+1]).AsBoolean)
              else
              begin
                s := FDS.fieldbyname(dane_pole[i+1]).AsString;
                if s <> '' then XlsWriteCellLabel(FStream,i,licznik,s);
              end;
        end;
/// write constans ***********
        If (UpperCase(dane_oper[i+1]) = 'CONST') then
        begin
          s := dane_cons[i+1] ;
          if s = ' ' then s := '';
          if UpperCase(dane_type[i+1]) = 'N' then
             XlsWriteCellNumber(FStream,i,licznik,StrToFloat(s))
            else
            if UpperCase(dane_type[i+1]) = 'I' then
               XlsWriteCellRk(FStream,i,licznik,StrToInt(s))
              else
              if  UpperCase(dane_type[i+1]) = 'B' then
                 begin
                 if (s <> '') and (UpperCase(s[1]) = 'T' ) then
                   XlsWriteCellBoolerr(FStream , i , licznik , True )
                   else XlsWriteCellBoolerr(FStream , i , licznik , False )
                 end
              else
              begin
                if s <> '' then XlsWriteCellLabel(FStream,i,licznik,s);
              end;
        end;
      end;

      if licznik mod 50 = 0 then
      begin
        Progress := (((licznik+1)*100) div RowsToSend) ;
        c2 := now;
        my_time := c2-c1;
        If Assigned(OnProgress) then
        OnProgress(self , Progress, licznik, my_time) ;
      end;
    until (licznik >= RowsToSend) or (FDS.eof);
//_______________________________________________

    Progress := (((licznik+1)*100) div RowsToSend) ;
    c2 := now;
    my_time := c2-c1;
    If Assigned(OnProgress) then
    OnProgress(self , Progress, licznik, my_time) ;

    XlsEndStream(FStream);
    FStream.Free;
  END;


//**********  Start OpenOffice CALC
  serviceManager := CreateOleObject('com.sun.star.ServiceManager');
  desktop := serviceManager.createInstance('com.sun.star.frame.Desktop');
//***** create property for OOO *****

  mypropo := VarArrayCreate([0, 0], varVariant);
  myprop := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
  myprop.Name := 'Hidden';
  ///////////////////////////////////////////////
  //DANGER If Hidden is True and  other OOCalc //
  //is on the focus then will be wrong!!!! //////
  ///////////////////////////////////////////////
  myprop.Value := False;

  mypropo[0] := myprop;

  myFile:= convertToURL(FName);
  calc := desktop.loadComponentFromURL(myFile , '_blank', 0, mypropo);
  mydesk := desktop.CurrentFrame;
  disp := serviceManager.createInstance('com.sun.star.frame.DispatchHelper');

  if (not fSaveAfterExport) and (not fCopyToNewCalc) then
  begin
    serviceManager := Unassigned;
    exit;
  end;
  if not fSaveAfterExport then
  begin
    disp.executeDispatch(mydesk, '.uno:SelectAll', '', 0, dummyArray );
    disp.executeDispatch(mydesk, '.uno:Copy', '', 0, dummyArray );
    calc2 := desktop.loadComponentFromURL('private:factory/scalc' , '_blank', 0, dummyArray);
    mydesk2 := desktop.CurrentFrame;
    disp.executeDispatch(mydesk2, '.uno:Paste', '', 0, dummyArray );
    Clipboard.Clear;
    myprop.Name := 'ToPoint';
    myprop.Value := '$A$1';
    mypropo[0] := myprop;
    disp.executeDispatch(mydesk2, '.uno:GoToCell', '', 0, mypropo);
    calc.close(True);
    serviceManager := Unassigned;
    DeleteFile(Fname);
    exit;
  end;
//******************************************
//*           SAVE AFTER EXPORT            *
//******************************************
  if FileToSave = ''  then
  begin
    Savedialog1.Title:= 'Save as...';
      if fExt_File = '.XLS' then
      begin
        SaveDialog1.Filter:='MsExcel Files (*.xls)|*.xls';
        SaveDialog1.DefaultExt:='xls';
      end;

      if fExt_File = '.ODS' then
      begin
        SaveDialog1.Filter:='Calc OpenOffice (*.ods)|*.ods';
        SaveDialog1.DefaultExt:='ods';
      end;

      if fExt_File = '.TXT' then
      begin
        SaveDialog1.Filter:='Text TAB Files (*.txt)|*.txt';
        SaveDialog1.DefaultExt:='xls';
      end;

      if fExt_File = '.CSV' then
      begin
        SaveDialog1.Filter:='MsExcel Files (*.csv)|*.csv';
        SaveDialog1.DefaultExt:='csv';
      end;

      SaveDialog1.InitialDir := ExtractFilePath(Application.ExeName);
      FileToSave:='';
      Application.BringToFront;
      if SaveDialog1.Execute then
        fFileToSave := SaveDialog1.FileName;
    end;

    if FileToSave <> '' then
    begin
      if UpperCase(ExtractFileExt(fFileToSave)) <> UpperCase(fExt_File) then
        fFileToSave := fFileToSave+fExt_File;
      if FExport_Format > 3 then my_properites := VarArrayCreate([0, 3], varVariant)
        else my_properites := VarArrayCreate([0, 2], varVariant);

      mypropo0 := VarArrayCreate([0, 0], varVariant);
      mypropo1 := VarArrayCreate([0, 0], varVariant);
      mypropo2 := VarArrayCreate([0, 0], varVariant);
      mypropo3 := VarArrayCreate([0, 0], varVariant);

      if FExport_Format = 1 then
      begin
        mypropo0 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo0.Name := 'URL';
        mypropo0.Value := convertToURL(fFileToSave);
        my_properites[0] := mypropo0;

        mypropo1 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo1.Name := 'FilterName';
        mypropo1.Value := 'MS Excel 97';
        my_properites[1] := mypropo1;

        mypropo2 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo2.Name := 'SelectionOnly';
        mypropo2.Value := True;
        my_properites[2] := mypropo2;
      end;

      if FExport_Format = 2 then
      begin
        mypropo0 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo0.Name := 'URL';
        mypropo0.Value := convertToURL(fFileToSave);
        my_properites[0] := mypropo0;

        mypropo1 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo1.Name := 'FilterName';
        mypropo1.Value := 'MS Excel 5.0/95';
        my_properites[1] := mypropo1;

        mypropo2 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo2.Name := 'SelectionOnly';
        mypropo2.Value := True;
        my_properites[2] := mypropo2;
      end;

      if FExport_Format = 3 then
      begin
        mypropo0 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo0.Name := 'URL';
        mypropo0.Value := convertToURL(fFileToSave);
        my_properites[0] := mypropo0;

        mypropo1 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo1.Name := 'FilterName';
        mypropo1.Value := 'calc8';
        my_properites[1] := mypropo1;

        mypropo2 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo2.Name := 'SelectionOnly';
        mypropo2.Value := True;
        my_properites[2] := mypropo2;
      end;

      if FExport_Format = 4 then
      begin
        mypropo0 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo0.Name := 'URL';
        mypropo0.Value := convertToURL(fFileToSave);
        my_properites[0] := mypropo0;

        mypropo1 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo1.Name := 'FilterName';
        mypropo1.Value := 'Text - txt - csv (StarCalc)';
        my_properites[1] := mypropo1;

        mypropo2 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo2.Name := 'FilterOptions';
        mypropo2.Value := '9,0,33';
        my_properites[2] := mypropo2;

        mypropo3 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo3.Name := 'SelectionOnly';
        mypropo3.Value := True;
        my_properites[3] := mypropo2;
      end;

      if FExport_Format = 5 then
      begin
        mypropo0 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo0.Name := 'URL';
        mypropo0.Value := convertToURL(fFileToSave);
        my_properites[0] := mypropo0;

        mypropo1 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo1.Name := 'FilterName';
        mypropo1.Value := 'Text - txt - csv (StarCalc)';
        my_properites[1] := mypropo1;

        mypropo2 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo2.Name := 'FilterOptions';
        mypropo2.Value := '59,0,33';
        my_properites[2] := mypropo2;

        mypropo3 := ServiceManager.Bridge_GetStruct('com.sun.star.beans.PropertyValue');
        mypropo3.Name := 'SelectionOnly';
        mypropo3.Value := True;
        my_properites[3] := mypropo2;
      end;

      disp.executeDispatch(mydesk, '.uno:SaveAs', '', 0, my_properites);
    end;

//******************************************
  DeleteFile(Fname);
  if Not fVisibleAfterExport then calc.close(True);
  serviceManager := Unassigned;

end;

procedure TGWGExporterOOC.setDefaultProperty;
begin
  MyWatch := True;
  fRows_to_send := 65535;
  fFirst_Rows_to_send := 1;
  fLast_Rows_to_send := 65535;
  setFExport_Format(1);
  fVisibleAfterExport := True;
  fFileToSave:='';
  fSaveAfterExport := False;
  FDataSet := NIL;
  FDBGrid := NIL;
  FDataLink.DataSource := NIL ;
  fCopyToNewCalc := False;
end;
//*********************************************
//** XLS***XLS***XLS***XLS***XLS***XLS***XLS **
//*********************************************

//THX to Tomasz Wasiuk ...
procedure TGWGExporterOOC.XlsBeginStream( const filename : String);
var
  XLS_HEADER : TResourceStream;
begin
  XLS_HEADER := TResourceStream.Create(HInstance, 'MY_HEAD_XLS', RT_RCDATA);
  XLS_HEADER.SaveToFile(filename);
  XLS_HEADER.Free;
end;

//***XLS***XLS***XLS***XLS***XLS***XLS***XLS***

procedure TGWGExporterOOC.XlsEndStream(XlsStream: TStream);
begin
  XlsStream.WriteBuffer(CXlsEof, SizeOf(CXlsEof));
end;
//***XLS***XLS***XLS***XLS***XLS***XLS***XLS***
procedure TGWGExporterOOC.XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word;
const AValue: string);
var
  L: Word;
begin
  L := Length(AValue);
  CXlsLabel[1] := 8 + L;
  CXlsLabel[2] := ARow;
  CXlsLabel[3] := ACol;
  CXlsLabel[5] := L;
  XlsStream.WriteBuffer(CXlsLabel, SizeOf(CXlsLabel));
  XlsStream.WriteBuffer(Pointer(AValue)^, L);
end;

//***XLS***XLS***XLS***XLS***XLS***XLS***XLS***

procedure TGWGExporterOOC.XlsWriteCellRk(XlsStream: TStream; const ACol, ARow: Word; const
AValue: Integer);
var 
  V: Integer; 
begin 
  CXlsRk[2] := ARow;
  CXlsRk[3] := ACol;
  XlsStream.WriteBuffer(CXlsRk, SizeOf(CXlsRk));
  V := (AValue shl 2) or 2; 
  XlsStream.WriteBuffer(V, 4); 
end;

//***XLS***XLS***XLS***XLS***XLS***XLS***XLS***

procedure TGWGExporterOOC.XlsWriteCellBoolerr(XlsStream: TStream; const ACol, ARow: Word;
const AValue: Boolean);
begin
  CXlsBoolerr[2] := ARow;
  CXlsBoolerr[3] := ACol;
  if AValue=False then CXlsBoolerr[5] := 0
  else CXlsBoolerr[5] := 1;
  XlsStream.WriteBuffer(CXlsBoolerr, SizeOf(CXlsBoolerr));
end;

procedure TGWGExporterOOC.XlsWriteCellNumber(XlsStream: TStream; const ACol, ARow: Word;
const AValue: Double);
begin
  CXlsNumber[2] := ARow;
  CXlsNumber[3] := ACol;
  XlsStream.WriteBuffer(CXlsNumber, SizeOf(CXlsNumber));
  XlsStream.WriteBuffer(AValue, 8);
end;
//*********************************************
//** XLS***XLS***XLS***XLS***XLS***XLS***XLS **
//*********************************************

//*****************************************
//** OPENOFFICE_TOOLS***OPENOFFICE_TOOLS **
//*****************************************
//**************************
//*Thanx to Bernard Marcell*
//**************************
function TGWGExporterOOC.convertToURL(winAddr: String): String;
var
  x : Integer; s, sLow : String;

  function escapeToUTF8URL(c: Char): String;
  var
    x: Integer;
  begin
    if ord(c) < 128  then begin
      x:= Pos(c, USASCIIexcl);
      if (c in ['0'..'9', 'a'..'z', 'A'..'Z']) or (x = 0) then
        Result:= c    // accepted, reserved or not reserved characters
      else            // excluded characters, to be converted
        Result:= Copy(USASCIIexcl, x+1, 3);
    end else begin    // convert to UTF8 with two bytes
      x:= Pos(c, UTF8chars);
      if x > 0 then
        Result:= Copy(UTF8chars, x+1, 6)
      else            // unknown character ( update table UTF8chars ? )
        Result:= '?';
    end;
  end;

  function existsPrefix: Boolean;
  var
    x: Integer;
  begin
    Result:= False;
    for x:= 1 to High(URLprefix) do begin
      if Pos(URLprefix[x], sLow) = 1 then
        begin Result:= True; break; end;
    end;
  end;

begin { -------- convertToURL ---------- }
  s:= StringReplace(winAddr, '\', '/', [rfReplaceAll]);
  sLow:= AnsiLowerCase(s);
  if existsPrefix then
    Result:= ''
  else
    if Pos('@', sLow) > 0 then
      Result:= 'mailto:'
    else
      Result:= 'file:///';
  for x:= 1 to Length(s) do
    Result:= Result + escapeToUTF8URL(s[x]);
end;

//** OPENOFFICE_TOOLS***OPENOFFICE_TOOLS **

function TGWGExporterOOC.dummyArray: Variant;
begin
  Result:= VarArrayCreate([0, -1], varVariant);
end;
//*****************************************
//** OPENOFFICE_TOOLS***OPENOFFICE_TOOLS **
//*****************************************


end.
